From 3e3e0af976aab5ec8095c464093ebb6665298db7 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 18 2020 06:03:24 +0000
Subject: [PATCH 165/2232] Allow catch behavior to be customized


If the user's cxx::bridge invocation includes any header that defines
the following function, they get it's behavior as the exception-to-Result
conversion.

    namespace rust::behavior {
    template <typename Try, typename Fail>
    static void trycatch(Try &&func, Fail &&fail) noexcept try {
      func();
    } catch (/* up to you */) {
      fail(/* const char *msg */);
    }
    }

The default behavior is equivalent to:

    } catch (const std::exception &e) {
      fail(e.what());
    }

Codebases that use Folly, for example, may be interested in behavior
like this instead for better type information on the error messages:

    } catch (const std::exception &e) {
      fail(folly::exceptionStr(e));
    } catch (...) {
      fail("<unknown exception>");
    }

---

diff --git a/gen/write.rs b/gen/write.rs
index 99260ea..de2d0cd 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -205,10 +205,21 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
         writeln!(out, "}};");
     }
 
+    out.end_block("namespace cxxbridge02");
+
     if needs_trycatch {
-        out.next_section();
+        out.begin_block("namespace behavior");
         out.include.exception = true;
-        writeln!(out, "template <typename Try, typename Fail>");
+        writeln!(out, "struct trycatch {{");
+        writeln!(out, "  template <typename T> trycatch(T);");
+        writeln!(out, "  static char use_default;");
+        writeln!(out, "}};");
+        writeln!(out);
+        writeln!(out, "template <typename Try, typename Fail,");
+        writeln!(
+            out,
+            "          typename = decltype(trycatch(std::declval<Try>()).use_default)>",
+        );
         writeln!(
             out,
             "static void trycatch(Try &&func, Fail &&fail) noexcept try {{",
@@ -217,9 +228,9 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
         writeln!(out, "}} catch (const ::std::exception &e) {{");
         writeln!(out, "  fail(e.what());");
         writeln!(out, "}}");
+        out.end_block("namespace behavior");
     }
 
-    out.end_block("namespace cxxbridge02");
     out.end_block("namespace rust");
 }
 
@@ -316,7 +327,7 @@ fn write_cxx_function_shim(out: &mut OutFile, efn: &ExternFn, types: &Types) {
     write!(out, "  ");
     if efn.throws {
         writeln!(out, "::rust::Str::Repr throw$;");
-        writeln!(out, "  ::rust::trycatch(");
+        writeln!(out, "  ::rust::behavior::trycatch(");
         writeln!(out, "      [&] {{");
         write!(out, "        ");
     }

